/*  XMPS - X MPEG Player System
 *  Copyright (C) 1999 Damien Chavarria
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 *  sdl_renderer : video interface to SDL display
 */

#ifndef _SDL_RENDERER_H
#define _SDL_RENDERER_H

/*********************************************************************
 *                             INCLUDES                              *
 *********************************************************************/

/*
 * includes : local
 *
 */

#include "stretch.h"
//#include "sdl_config.h"

/*
 * includes : system
 *
 */

#include <SDL/SDL.h>

#include "libxmps/libxmps.h"

#include <gtk/gtk.h>
#include <gdk/gdkprivate.h>

#include <X11/Xlib.h>

/*********************************************************************
 *                           PROTOTYPES                              *
 *********************************************************************/

unsigned int     sdl_open (xmps_video_renderer_plugin_t *xmps_video_renderer);
void*            sdl_get  (xmps_video_renderer_plugin_t *xmps_video_renderer, unsigned int flag, void* data);
unsigned int     sdl_set  (xmps_video_renderer_plugin_t *xmps_video_renderer, unsigned int flag, void *data);
unsigned int     sdl_draw (xmps_video_renderer_plugin_t *xmps_video_renderer, void *image);
unsigned int     sdl_close(xmps_video_renderer_plugin_t *xmps_video_renderer);

#endif
